#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define tam 5

typedef struct colecao//estrutura que armazena as informaes do CD
{
    char genero;
    int codigo;
    char *conjunto;
}Colecao;

void preencheColecao (Colecao *CD);
void imprime (char generoEscolhido, Colecao *CD);


int main()
{
    int i;
    char generoEscolhido;
    Colecao *CD;
    CD = (Colecao *) malloc (tam * sizeof (Colecao));//aloca o vetor de estruturas
    for (i = 0; i < tam; i++)
    {
        CD[i].conjunto = (char *) malloc (101* sizeof (char));//aloca o nome do conjunto que est na estrutura
    }
    preencheColecao (CD);//preenche o vetor de estruturas
    do
    {
        fflush (stdin);
        printf ("\n\nDigite o genero escolhido para imprimir as bandas disponiveis (R/P/S/O): ");//pega o gnero escolhido
        scanf ("%c", &generoEscolhido);
        if (generoEscolhido != 'R' && generoEscolhido != 'P' && generoEscolhido != 'S' && generoEscolhido != 'O')
        {
            printf ("\nGenero Invalido!!\n\n");
        }
    }
    while (generoEscolhido != 'R' && generoEscolhido != 'P' && generoEscolhido != 'S' && generoEscolhido != 'O');

    imprime (generoEscolhido, CD);//imprime os CDs com o gnero escolhido
    for (i = 0; i < tam; i++)
    {
         free (CD[i].conjunto);//desaloca os nomes
    }
    free (CD);//desaloca o vetor de estruturas

    return 0;
}

void preencheColecao (Colecao *CD)//preenche o vetor de estruturas
{
    int i, j, codigoValido = 1;
    for (i = 0; i < tam; i++)
    {

        do
        {
            printf ("\nDigite o codigo do CD %d: ", i + 1);//pega o cdigo do CD
            scanf ("%d", &CD[i].codigo);
            if (CD[i].codigo < 0)
            {
                printf ("\nCodigo invalido!!\n");
            }
            for (j = 0; j < i; j++)//verifica se o cdigo j foi digitado previamente
            {
                if (CD[i].codigo == CD[j].codigo)
                {
                    printf ("\nCodigo ja foi digitado!!\n");
                    codigoValido = 0;
                    break;
                }
                else
                {
                    codigoValido = 1;
                }
            }
        }
        while (CD[i].codigo < 0 || codigoValido == 0);

        do
        {

            fflush (stdin);
            printf ("\n\nDigite o nome do conjunto do CD %d: ", i + 1);//pega o nome do conjunto
            gets (CD[i].conjunto);
            if (strlen (CD[i].conjunto)== 0)
            {
                printf ("\nNome do conjunto invalido!\n");
            }
        }
        while (strlen (CD[i].conjunto)== 0);

        do
        {
            fflush (stdin);
            printf ("\n\nDigite o genero da musica do CD %d(R/P/S/O): ", i + 1);//pega o genero da msica
            scanf ("%c", &CD[i].genero);
            if (CD[i].genero != 'R' && CD[i].genero != 'P' && CD[i].genero != 'S' && CD[i].genero != 'O')
            {
                printf ("\nGenero Invalido!!\n");
            }
        }
        while (CD[i].genero != 'R' && CD[i].genero != 'P' && CD[i].genero != 'S' && CD[i].genero != 'O');
    }
}

void imprime (char generoEscolhido, Colecao *CD)//imprime os CDs com o gnero escolhido
{
    int i, generoAchado = 0;
    for (i = 0; i < tam; i++)
    {
        if (CD[i].genero == generoEscolhido)//se o genero do CD for igual ao genero escolhido, imprime suas informaes
        {
            generoAchado = 1;
            printf ("Codigo do CD: %d\n", CD[i].codigo);
            printf ("Nome da Banda: ");
            puts (CD[i].conjunto);
            printf ("\n\n");
        }
    }
    if (generoAchado == 0)//imprime caso no seja nenhum CD com esse genero
    {
        printf ("\nNao existe nenhum CD com esse genero\n");
    }
}


